#include "stdafx.h"
#include "MyContentType.h"
#include "httphelper.h"

#define OCTET_STREAM	"application/octet-stream"
#define MIMETYPE_FILE_NAME L"\\AddType.txt"

//-----------------------------------------------------------------------------
//	@detail
//		
//	@param
//		
//	@return
//		
//-----------------------------------------------------------------------------
MyContentType::MyContentType()
{
	// ----------------------------------------------------
	// Load default mime type
	// ----------------------------------------------------

	Set(".html",	"text/html"						);
	Set(".htm",		"text/html"						);
	Set(".gif",		"image/gif"						);
	Set(".png",		"image/png"						);
	Set(".jpg",		"image/jpeg"					);
	Set(".jpeg",	"image/jpeg"					);
	Set(".txt",		"text/plain"					);
	Set(".css",		"text/css"						);
	Set(".bmp",		"image/bitmap"					);
	Set(".tif",		"image/tiff"					);
	Set(".tiff",	"image/tiff"					);
	Set(".mpg",		"video/mpeg"					);
	Set(".mpeg",	"video/mpeg"					);
	Set(".pdf",		"application/pdf"				);
	Set(".ls",		"application/x-javascript"		);
	Set(".js",		"application/x-javascript"		);
	Set(".mp3",		"audio/mp3"						);
	Set(".m3u",		"audio/x-mpegurl"				);
	Set(".wav",		"audio/x-wav"					);
	Set(".mid",		"audio/mid"						);
	Set(".midi",	"audio/mid"						);
	Set(".swf",		"application/x-shockwave-flash"	);

	WCHAR pwszDir[MAX_PATH];

	// ----------------------------------------------------
	// Load mime txt
	// ----------------------------------------------------

	GetCurrentDirW(pwszDir, MAX_PATH);
	wcscat(pwszDir, MIMETYPE_FILE_NAME);
	LoadFile(pwszDir);

	// ----------------------------------------------------
	// Load modules
	// ----------------------------------------------------

	GetCurrentDirW(pwszDir, MAX_PATH);
	wcscat(pwszDir, L"\\");
	LoadModFile(pwszDir);
}

MyContentType::~MyContentType()
{
}

//-----------------------------------------------------------------------------
//	@detail
//		Serch mime-type from file-type
//		This function is to avoid multi-thread safe.
//	@param
//		cahr*	pszKey;		mimetype find key
//	@return
//		Mime type strings
//		This must not be null string
//-----------------------------------------------------------------------------
char* MyContentType::GetMimeType( char *pszExtend )
{
	char* p = GetValueEx( pszExtend );

	if( p == NULL )
	{
		// If mime type is unknown, set octet-stream.
		return OCTET_STREAM;
	}

	return p;
}

//-----------------------------------------------------------------------------
//	@detail
//		Load modules
//		To add the tabele of MIME-type extensions dynamically, 
//		this function serch pwszDir *.mod files.
//		When xxx.mod extension found, add xxx MIME-type to the table.
//	@param
//		WCHAR*	pwszDir;	directory	(UTF-2)
//	@return
//		0 indicate an error
//-----------------------------------------------------------------------------
int MyContentType::LoadModFile( WCHAR* pwszDir )
{
	HANDLE hFFF = INVALID_HANDLE_VALUE;
	WIN32_FIND_DATA wfdFile = {0};

	WCHAR wszModuleFile[MAX_PATH];
	char szModuleFile[MAX_PATH];

	WCHAR wszFileStrip[MAX_PATH];
	char szFileStrip[MAX_PATH];
	
	WCHAR wszFindPath[MAX_PATH];
	wcscpy( wszFindPath, pwszDir );
	wcscat( wszFindPath, L"*.mod");

	hFFF = FindFirstFile( wszFindPath, &wfdFile );

	if( hFFF == INVALID_HANDLE_VALUE  )
		return 0;


	do
	{
		// file path
		wcscpy( wszModuleFile, pwszDir );
		wcscat( wszModuleFile, wfdFile.cFileName );

		// mime type
		WCHAR* pFileName = wfdFile.cFileName;
		WCHAR* pDst = wszFileStrip;

		*pDst++ = '.';

		while( *pFileName != '.' )
		{
			*pDst++ = *pFileName++;
		}
		*pDst = '\0';

		WideCharToMultiByte(CP_ACP, 0, wszFileStrip, -1, szFileStrip, MAX_PATH, NULL, NULL);
		WideCharToMultiByte(CP_ACP, 0, wszModuleFile, -1, szModuleFile, MAX_PATH, NULL, NULL);
		Set(szFileStrip, szModuleFile);

	}while( FindNextFile(hFFF, &wfdFile) );

	FindClose( hFFF );

	return 1;
}