#include <stdlib.h>
#include "httphelper.h"
#include "cehttp.h"

// ----------------------------------------------------------------------------
// HELPER FUNCTIONS
// ----------------------------------------------------------------------------

int GetCurrentDirW(WCHAR* pwszDir, int nBufLen)
{
	DWORD dwLen;

	memset( pwszDir, 0, sizeof(WCHAR)*nBufLen );

	dwLen = GetModuleFileName( NULL, pwszDir, nBufLen );
	
	if( dwLen == 0 )
		return 0;

#if defined(WIN32) && !defined(_WIN32_WCE)
	// Remove drive letter.
	WCHAR* pwSrc = pwszDir;
	WCHAR* pwDest = pwSrc;
	pwSrc += 2;

	dwLen -=2;	// length of drive letter.
	
	do
	{
		*pwDest++ = *pwSrc;
	}while( *pwSrc++ != '\0' );
#endif
	
	dwLen--;

	while( pwszDir[dwLen] != '\0' && pwszDir[dwLen] != '\\' )
	{
		dwLen--;
		if( dwLen == 0 )
			break;
	}

	pwszDir[dwLen] = '\0';

	return dwLen;
}


static char B64(char c)
{
	if( c == '=' ) return 0;
	const char b64[] ="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
	for( char ii = 0; b64[ii] != c && b64 != '\0'; ii++ );
	return ii;
}

char* Base64Decord(unsigned char *buf)
{
    char *p = (char*)buf;

    int l = strlen((const char*)buf);
    for (int ii=0,jj=0; ii<l; ii+=4, jj+=3)
	{
        p[jj]   =(char)(  (B64(buf[ii])           << 2) | ((B64(buf[ii+1]) & 0x30) >> 4) );
        p[jj+1] =(char)( ((B64(buf[ii+1]) & 0x0f) << 4) | ((B64(buf[ii+2]) & 0x3c) >> 2) );
        p[jj+2] =(char)( ((B64(buf[ii+2]) & 0x03) << 6) |  (B64(buf[ii+3]) & 0x3f)       );
    }
    p[jj] = '\0';
    return (p);
}

//-----------------------------------------------------------------------------
// '/' -> '\\'
void slash2bslash(char* str)
{
	if( str == NULL )
		return;

	for( ;*str;str++)
		if( *str == '/' ) *str = '\\';
}

//-----------------------------------------------------------------------------
// '/' <- '\\'
void bslash2slash(char* str)
{
	if( str == NULL )
		return;

	for( ;*str;str++)
		if( *str == '\\' ) *str = '/';
}

//-----------------------------------------------------------------------------
// char to wchar with malloc
WCHAR* malloc_char2wchar(char* pszStr)
{
	WCHAR* pwsRet = NULL;
	int nRet = 0;

	nRet = MultiByteToWideChar(CP_ACP,0,pszStr,-1,NULL,0);

	if( nRet == 0 )
	{
		return NULL;
	}

	pwsRet = (WCHAR*)MALLOC( nRet * sizeof(WCHAR) );

	if( 0 == MultiByteToWideChar(CP_ACP,0,pszStr,-1,pwsRet,nRet) )
	{
		free( pwsRet );
		return NULL;
	}

	return pwsRet;

}

//-----------------------------------------------------------------------------
// FindFirstFile MBCS
HANDLE FindFirstFileMBCS(char* lpFileName, LPWIN32_FIND_DATA lpFindFileData )
{
	TCHAR	tszFile[MAX_PATH];

	if( 0 == MultiByteToWideChar(CP_ACP,0,lpFileName,-1,tszFile,MAX_PATH) )
	{
		return INVALID_HANDLE_VALUE;
	}

	return FindFirstFile(tszFile, lpFindFileData );
}
