// -------------------------------------------------------------------------
// STR.H
// ANSI STANDARD C STRING LIBRARY
// date:	12/jul/2003
// author:	Yuichiro Ishitani <yu-ishi@ya2.so-net.ne.jp>
// -------------------------------------------------------------------------

#if !defined(size_t)
#define size_t unsigned int
#endif

#ifndef NULL
#ifdef __cplusplus
#define NULL	0
#else
#define NULL	((void *)0)
#endif
#endif

#ifdef __cplusplus
extern "C" {
#endif


size_t	STRLEN( const char *string );
char	*STRCPY( char *dst, const char *src );
char	*STRNCPY( char *dst, const char *src, size_t count );
char	*STRUPR( char *src );
char	*STRLWR( char *src );
char	*STRCAT( char *dst, const char *src );
char	*STRNCAT( char *dst, const char *src, size_t count );
char	*STRSET( char *src, int c );
int		STRICMP( const char *str1, const char *str2 );
int		STRNCMP( const char *str1, const char *str2, size_t count );
int		STRNICMP( const char *str1, const char *str2, size_t count );
char	*STRDUP( const char *src );
char	*STRREV( char *string );
char	*STRCHR( const char *string, int c );
char	*STRRCHR( const char *string, int c );
char	*STRSTR( const char *dst, const char *src );
size_t	STRSPN( const char *dst, const char *src );
size_t	STRCSPN( const char *dst, const char *src );
char	*STRTOK( char *dst, const char *dlmt );

#ifdef __cplusplus
}
#endif

